module Ignatius
  class GoogleDrive
    def shared_folder(url)
      html = shared_folder_html(url)
      links = grab_links(html)
    end

  # private----------------------------------------------

    def shared_folder_html(url)
      Nokogiri::HTML(open(url))
    end

    def id(node)
      node.attr('id')
    end

    def clean_image_id(id)
      id.gsub(/entry-/, '')
    end

    def downloadable(id)
      "https://drive.google.com/uc?export=download&id=#{id}"
    end

    def node_to_download_link(node)
      (nid = id(node)) ? downloadable(clean_image_id(nid)) : nil
    end

    def grab_links(html)
      html.css('.flip-entry').map{ |n| node_to_download_link(n) }
    end
  end
end
